// -*- tab-width:2 ; indent-tabs-mode:nil -*-
//:: cases ForkJoinTask
//:: tools silicon
//:: verdict Pass

/* To verify this example:

  vct --silver=silicon ValueContainer.java ForkJoinTask.java ForkJoinTaskMain.java
  
 */
//begin(all)
public class Main {

  public static void main(int[] output){
    ForkJoinTask task = new ForkJoinTask();
    
    ValueContainer vc = task.get()/*@ with { p = 1; } @*/;
    //@ unfold task.postGet(vc);
    
    int result = vc.get()/*@ with { p = 1; res = 5; } @*/;
    
    //@ assert result == 5;
    //@ refute false; // skip(all)
  }
}
//end(all)
