// -*- tab-width:2 ; indent-tabs-mode:nil -*-
//:: case FlagAxioms
//:: tool silicon
//:: options --check-axioms

//:: case FlagDefined
//:: tool silicon
//:: options --check-defined

/*
  vct --silver=silicon --check-axioms Flags.java
  vct --silver=silicon --check-defined Flags.java
*/


class Future {

  boolean flag;

/*@
  modifies flag;
  ensures  flag==!v && \old(flag)==v;
  process  flipFlag(boolean v);
  
 
  modifies flag;
  process  flipOmega(boolean v)=flipFlag(v)*flipOmega(v);
  
  
  modifies flag;
  requires flag;
  process  flip()=flipFlag(true)*flop();
  
  modifies flag;
  requires !flag;
  process  flop()=flipFlag(false)*flip();
  
  
  ensures flip()==(flipOmega(true)||flipOmega(false));
  void flip_lemma(boolean v);

  ensures flop()==(flipOmega(true)||flipOmega(false));
  void flop_lemma(boolean v);
@*/
  
}

