// -*- tab-width:2 ; indent-tabs-mode:nil -*-
//:: case NoSendAfterRead

class Lock {
  //@ Future fut;
  
  boolean flag;
  
  /*@ inline resource invariant(frac p)=
        Value(fut)**
        Perm(flag,p)**
        (flag?HPerm(fut.flag,p):HPerm(fut.flag,read))**
        fut.flag==flag; @*/
  
  //@ ensures invariant(write);
  void wr_lock();
  
  //@ requires invariant(write);
  void wr_unlock();
  
  //@ ensures invariant(1/4);
  void rd_lock();
  
  //@ requires invariant(1/4);
  void rd_unlock(); 
}
