import java.io.Serializable;

public class MathRemote implements RemoteObject {
    private final int workerId;
    private final int objectId;

    public MathRemote(int workerId, int objectId) {
        this.workerId = workerId;
        this.objectId = objectId;
    }

    /*@
        requires b != 0 ** a % b == 0;
    @*/
    public RemoteFuture<Integer> divide(int a, int b) {
        return new RemoteFuture<Integer>(
                MPAO.callMethod(workerId, objectId, "divide",
                                new Serializable[] { a, b }));
    }
}
